--sleepyzay--

fn paddstring len instring = (
	instring=instring as string
	local str=""
	if instring.count <=len then (
		for i = 1 to (len-instring.count) do(
			str+="0"
		)
		str = (str+instring)
	)
	else (
		for i = 1 to len do(
			str+="0";str[i]=instring[i]
		)
	)
	str
)
fn addHexaDecimalPadding nr = (
	case of (
		(nr <= 15): ("0" + ((bit.intAsHex(nr))as string))
		(nr > 15): ((bit.intAsHex(nr))as string)
	)
)
fn ReadFixedString bstream fixedLen = (
   local str = ""
   For i = 1 to fixedLen do
   (
      str0 = ReadByte bstream #unsigned
      If str0!=0xFD AND str0!=0xFC do str+= bit.intAsChar str0
   )
   str
)
fn ReadFixedByteString bstream fixedLen var var2 = (
   local str = ""
   For i = 1 to fixedLen do
   (
      str += addHexaDecimalPadding (ReadByte bstream #unsigned)
	  If mod i 1 == 0 do str += " "
   )
   str
   if var == 1 do fseek f -fixedLen #seek_cur
   if var2 == 1 do print str
)
fn printHex num = (
	print (bit.intashex(num))
)
fn printHere bstream = (
	Print ("Here @ 0x"+((bit.intAsHex(ftell bstream))as string))
)
fn getBoundBox bstream fscale = (
	currBBMax = ([(readfloat bstream),(readfloat bstream),(readfloat bstream)]*fscale)
	currBBMin = ([(readfloat bstream),(readfloat bstream),(readfloat bstream)]*fscale)
	currA = currBBMax - currBBMin
	
	return currA
)
fn getName bstream offset = (
	backJump = ftell bstream
	fseek bstream offset #seek_set
	str = readstring bstream
	fseek bstream backJump #seek_set
	return str
)
fn skelPresent = (
	BNArr = for o in geometry where classOf o == boneGeometry collect o
	if BNArr.count > 0 then (
		return true
	)
	else (
		return false
	)
)

struct weight_data (
	boneids,weights
)

fname = GetOpenFileName caption:"The King of Fighters: World" types:"Geometry (*.skin)|*.skin"
If (fname!=undefined) and ((DoesFileExist fname)==true) then (
f = fopen fname "rb"   --open file in read only format
-- actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
FileExtension = getFileNameType  fname
FileName = getFileNameFile fname
FilePath = getFileNamePath fname


clearlistener()
Global fscale=100
-- delete $*
Print "===================================="
print (FileName + FileExtension) as string
Print "===================================="
--)
gname = GetOpenFileName caption:"Total War - Warhammer Skeleton" types:"Skeleton (.skel)|*.skel"
If (gname!=undefined) and ((DoesFileExist gname)==true) then (
	g = fopen gname "rb"
	delete $*
	
	skelCount = readlong g
	boneCount = readlong g
	BNArr=#()
	for x=1 to boneCount do (
		stringLength = readlong g
		boneName = ReadFixedString g stringLength
		parentID = readlong g + 1
		m11 = Readfloat g; m12 = Readfloat g; m13 = Readfloat g; m14 = Readfloat g
		m21 = Readfloat g; m22 = Readfloat g; m23 = Readfloat g; m24 = Readfloat g
		tfm = (quat m21 m22 m23 m24) as matrix3	
		tfm.row4 = ([m11,m12,m13] * fscale)
		
		newBone = bonesys.createbone	\
		tfm.row4	\
		(tfm.row4 + 0.01 * (normalize tfm.row1)) \
		(normalize tfm.row3)
		newBone.width  = 0.01
		newBone.height = 0.01
		newBone.transform = tfm
		newBone.setBoneEnable false 0
		newBone.wirecolor = yellow
		newbone.showlinks = true
		newBone.pos.controller      = TCB_position ()
		newBone.rotation.controller = TCB_rotation ()
		newBone.name = boneName
		
		if (parentID != 0) then(
			newBone.parent = BNArr[parentID]
		)
		
		append BNArr newBone

	-- 	ReadFixedByteString f 0x24 0 1
	)
	rootRT = dummy name:"Main_Root" boxsize:[.1,.1,.1]
	for b in BNArr where b.parent==undefined do b.parent = rootRT
	rootRT.transform = (matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0])
	for a in BNArr do (
		a.setskinpose()
	)
)
gc()
fclose g

ukw = readlong f
meshCount = readlong f
fseek f 0x50 #seek_set
for x=1 to meshCount do (
	Vert_array=#()
	UV_array=#()
	Face_array=#()
	Normal_array=#()
	Weight_array=#()
	
	stringLength = readlong f
	meshName = ReadFixedString f stringLength
	stringLength = readlong f
	texName = ReadFixedString f stringLength
	
	ukw2 = readshort f
	vertFlag = readshort f
	ukw3 = readlong f
	fseek f 0x48 #seek_cur
	boneIDCount = readlong f
	boneMap = for x=1 to boneIDCount collect (readlong f)
	
	vertCount = readlong f
	for y=1 to vertCount do (
		w = (weight_data boneids:#() weights:#())
		
		vx = readfloat f
		vy = readfloat f
		vz = readfloat f
		nx = readfloat f
		ny = readfloat f
		nz = readfloat f
		tu = readfloat f
		tv = readfloat f
		
		if vertFlag == 1 do (	--uv's?
			ukw = readfloat f
			ukw2 = readfloat f
		)
		
		bone1 = readbyte f + 1
		bone2 = readbyte f + 1
		bone3 = readbyte f + 1
		bone4 = readbyte f + 1
		weight1 = readfloat f
		weight2 = readfloat f
		weight3 = readfloat f
		weight4 = 0
		
		if vertFlag == 256 do (
			tx = readfloat f
			ty = readfloat f
			tz = readfloat f
			b1 = readfloat f
			b2 = readfloat f
			b3 = readfloat f
		)
		
		maxweight = 0
		if(bone1 != 0) then
			maxweight += weight1
		if(bone2 != 0) then
			maxweight += weight2
		if(bone3 != 0) then
			maxweight += weight3
		if(bone4 != 0) then
			maxweight += weight4
			
		if(maxweight != 0) then (
			mxw = 255.0
			if(weight1 != 0) then (
				w1 = weight1 as float
				append w.boneids (boneMap[bone1] + 1)
				append w.weights (w1 / mxw)
			)
			if(weight2 != 0) then (
				w2 = weight2 as float
				append w.boneids (boneMap[bone2] + 1)
				append w.weights (w2 / mxw)
			)
			if(weight3 != 0) then (
				w3 = weight3 as float
				append w.boneids (boneMap[bone3] + 1)
				append w.weights (w3 / mxw)
			)
			if(weight4 != 0) then (
				w4 = weight4 as float
				append w.boneids (boneMap[bone4] + 1)
				append w.weights (w4 / mxw)
			)		
		)
		
		append Vert_array([vx,vy,vz]*fscale)
		append Normal_array[nx,ny,nz]
		append UV_array[tu,1-tv,0]
		append Weight_array w
	)
	faceCount = readlong f
	for y=1 to faceCount do(
		fa = readshort f #unsigned + 1
		fb = readshort f #unsigned + 1
		fc = readshort f #unsigned + 1
		append Face_array[fa,fc,fb]
	)
	fseek f 0x18 #seek_cur	--bb info

	msh = mesh vertices:Vert_array faces:Face_array 
	msh.numTVerts = UV_array.count
	msh.name = meshName
	buildTVFaces msh
	msh.wirecolor = random black white
	for j = 1 to UV_array.count Do setTVert msh j UV_array[j]
	for j = 1 to Face_array.count Do setTVFace msh j Face_array[j]
	for j = 1 to Normal_array.count do setNormal msh j Normal_array[j]
	msh.transform=(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0])
	
	if skelPresent() == true do (
		BNArr = for o in geometry where classOf o == boneGeometry collect o
		
		max modify mode
		select msh
		skinMod = skin ()
		addModifier msh skinMod
		for i = 1 to BNArr.count do (
			
			maxbone = getnodebyname BNArr[i].name
			if i != BNArr.count then
				skinOps.addBone skinMod maxbone 0
			else
				skinOps.addBone skinMod maxbone 1
			
		)
		
		modPanel.setCurrentObject skinMod
		for i = 1 to Weight_array.count do (
			w = Weight_array[i]
			bi = #() --bone index array
			wv = #() --weight value array
			
			for j = 1 to w.boneids.count do (
				boneid = w.boneids[j]
				weight = w.weights[j]
				append bi boneid
				append wv weight
			)	
			
			skinOps.ReplaceVertexWeights skinMod i bi wv
		)
	)
)

Print ("Last Read @ 0x"+((bit.intAsHex(ftell f))as string))
)
gc()
fclose f